// -*- C++ -*-
// $Header: /cvs/omnetpp/ip-suite/UDP/UDPApp.h,v 1.3 2000/12/11 10:18:52 kaage Exp $
//
// Copyright (C) 2000 Institut fuer Telematik, Universitaet Karlsruhe
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
/*
	file: UDPApp.h
	author: Jochen Reber
*/

#ifndef __UDPAPP_H__
#define __UDPAPP_H__

#include <omnetpp.h>

#include "IPInterfacePacket.h"

class UDPAppBase: public cSimpleModule
{
protected:
	char _nodename[NODE_NAME_SIZE];
	// IPAddress _local_addr, _dest_addr;
	int _local_port, _dest_port;
	int _msg_length;
	simtime_t _msg_freq;
	int _destType;

public:
    Module_Class_Members(UDPAppBase, cSimpleModule, 0);

	virtual void initialize();

};

class UDPServer: public UDPAppBase
{
	void processMessage(cMessage *msg);
public:
    Module_Class_Members(UDPServer, UDPAppBase, ACTIVITY_STACK_SIZE);

	virtual void activity();

};

class UDPClient: public UDPAppBase
{
	int contCtr;
	char *chooseDestAddr(char *dest);

public:
    Module_Class_Members(UDPClient, UDPAppBase, ACTIVITY_STACK_SIZE);

	virtual void initialize();
	virtual void activity();

};

#endif
