// -*- C++ -*-
// $Header: /cvs/omnetpp/ip-suite/UDP/UDPProcessing.h,v 1.2 2000/11/22 09:05:20 kaage Exp $
//
// Copyright (C) 2000 Institut fuer Telematik, Universitaet Karlsruhe
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

/* 	-------------------------------------------------
	file: UDPProcessing.h
	Purpose: Header file for UDP Layer
	------
	Responsibilities: 
		see .cc file
	author: Jochen Reber
	------------------------------------------------- 	*/

#ifndef __UDPPROCESSING_H__ 
#define __UDPPROCESSING_H__

#include "basic_consts.h"
#include "ProcessorAccess.h"

/* 	-------------------------------------------------
		Constants
	------------------------------------------------- 	*/
const int MAXUDPAPPS = 20;
const char *ERROR_IP_ADDRESS = "10.0.0.255";

/* 	-------------------------------------------------
		Additional Structures
	------------------------------------------------- 	*/
struct UDPApplicationTable
{
	int size;
	int port[MAXUDPAPPS];
};

/* 	-------------------------------------------------
		main Module: UDPProcessing	
	------------------------------------------------- 	*/
class UDPProcessing: public ProcessorAccess
{
private:

	UDPApplicationTable applTable;

	void processMsgFromIp(cMessage *);
	void processMsgFromApp(cMessage *);
public:
    Module_Class_Members(UDPProcessing, ProcessorAccess, 
				ACTIVITY_STACK_SIZE);

	virtual void initialize();
    virtual void activity();

};

#endif

